SystemOrganization addCategory: #ProxiesTests!

TestCase subclass: #AbstractCompiledMethodProxyTest
	instanceVariableNames: 'proxyClass proxyInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 12/13/2010 20:15'!
crashTestCompiledMethodProxy2
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: PseudoContext  selector: #isPseudoContext.
	[self assert: (PseudoContext methodDict mareaAt: #isPseudoContext) class name equals:  self proxyClassName.
	aProxy zaraza.
	self assert: (PseudoContext methodDict mareaAt: #isPseudoContext) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'helper' stamp: 'MarianoMartinezPeck 11/20/2010 18:21'!
installCompiledMethodProxyOn: aClass selector: aSelector
	^ self proxyClass installOn: aClass selector: aSelector.! !

!AbstractCompiledMethodProxyTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/30/2010 17:24'!
proxyClass
	^ proxyClass
	

! !

!AbstractCompiledMethodProxyTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/30/2010 17:25'!
proxyClassInstance
	^ proxyInstance
	

! !

!AbstractCompiledMethodProxyTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/20/2010 18:11'!
proxyClassName
	^ self proxyClass name! !

!AbstractCompiledMethodProxyTest methodsFor: 'running' stamp: 'MarianoMartinezPeck 3/31/2011 10:23'!
setUp
	CompiledMethodProxySwapperHandler mareaSerializer: FuelMareaSerializer. 
	FilenameCompiledMethodProxySwapper runningTest: true.
	proxyClass := FilenameCompiledMethodProxySwapper.
	proxyInstance := FilenameCompiledMethodProxySwapper new.
	
	(FileDirectory default fileNamesMatching: '*.swap*') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'running' stamp: 'MarianoMartinezPeck 11/27/2010 16:48'!
tearDown
	(FileDirectory default fileNamesMatching: '*.swap*') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodMessageSent
	"A simple CompiledMethodProxy test"
	| aProxy |
	
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  self proxyClassName.
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also."
	self assert: (ClassWith1Var methodDict mareaAt: #foo) literals size equals: 3.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodMessageSentByPerform
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  self proxyClassName.
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also."
	self assert: ((ClassWith1Var methodDict mareaAt: #foo) perform: #literals) size equals: 3.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodMessageSentByPerformWith
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo:.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo:) class name equals:  self proxyClassName.
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also."
	self assert: ((ClassWith1Var methodDict mareaAt: #foo:) perform: #literals) size equals: 3.
	self assert: (ClassWith1Var methodDict mareaAt: #foo:) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodMessageSentByPerformWithNotUnderstood
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  self proxyClassName.
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also."
	self should: [(ClassWith1Var methodDict mareaAt: #foo) perform: #nonExistentMethod] raise: Error.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodMessageSentByPerformWithNotUnderstood2
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  self proxyClassName.
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also." 
	self should: [(ClassWith1Var methodDict mareaAt: #foo) perform: #fooDNU] raise: Error.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:01'!
testCompiledMethodProxy
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  self proxyClassName.
	self assert: (ClassWith1Var new foo = 'foo').
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyAllInstalledProxiesCount
	"A simple CompiledMethodProxy test"
	| aProxy aProxy2 aProxy3 |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	aProxy2 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo2.
	aProxy3 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo3.
	[self assert: self proxyClass mareaAllInstalledProxiesCount equals: 3.
	"This will automatically uninstall the proxy"
	ClassWith1Var new foo.
	self assert: self proxyClass mareaAllInstalledProxiesCount equals: 2.
	aProxy2 mareaUninstallIfNeeded. 
	self assert: self proxyClass mareaAllInstalledProxiesCount equals: 1.
	] ensure: [ 
		aProxy mareaUninstallIfNeeded.
		aProxy2 mareaUninstallIfNeeded.
		aProxy3 mareaUninstallIfNeeded.].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyAndGC
	"A simple CompiledMethodProxy test"
	| aProxy methodsInstCountFirst  methodsInstCountEnd proxyCount proxyCountEnd|
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	methodsInstCountFirst := CompiledMethod instanceCount.
	proxyCount := self proxyClass instanceCount.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  self proxyClassName.
	"This line is important because the MCMethodDefinition have references to the CompiledMethod"
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	methodsInstCountEnd := CompiledMethod instanceCount.
	proxyCountEnd := self proxyClass instanceCount.
	self assert: (methodsInstCountFirst - 1) equals: methodsInstCountEnd.
	(self proxyClass = SmallInteger) ifFalse: [self assert: (proxyCount + 1) equals: proxyCountEnd].
	self assert: (ClassWith1Var new foo = 'foo').
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	aProxy := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	methodsInstCountEnd := CompiledMethod instanceCount.
	proxyCountEnd := self proxyClass instanceCount.
	self assert: methodsInstCountFirst equals: methodsInstCountEnd.
	self assert: proxyCount equals: proxyCountEnd.
	] ensure: [
		aProxy isNil ifFalse: [aProxy mareaUninstallIfNeeded].
		MCMethodDefinition shutDown. 
		Smalltalk garbageCollect].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyAndPerform
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: ((ClassWith1Var methodDict mareaAt: #foo) class name = self proxyClassName).
	self assert: ((ClassWith1Var new perform: #foo) = 'foo').
	self assert: ((ClassWith1Var methodDict mareaAt: #foo) class name = #CompiledMethod).
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyAndPerformWith
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo:.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo:) class name equals:  self proxyClassName.
	self assert: (ClassWith1Var new perform: #foo: with: 2) equals: 'foo'.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyAndPerformWithNotUnderstood2
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #fooDNU.
	[self assert: (ClassWith1Var methodDict mareaAt: #fooDNU) class name equals:  self proxyClassName.
	self should: [ClassWith1Var new perform: #fooDNU ] raise: Error. 
	self assert: (ClassWith1Var methodDict mareaAt: #fooDNU) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyCaseSensitive
	"A simple CompiledMethodProxy test"
	| aProxy aProxy2 |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	aProxy2 := self installCompiledMethodProxyOn: ClassWith1Var selector: #fOO.
	
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	self assert: (ClassWith1Var methodDict mareaAt: #fOO) class name equals: self proxyClassName.
	self assert: ClassWith1Var new foo equals: 'foo'.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	self assert: (ClassWith1Var methodDict mareaAt: #fOO) class name equals: self proxyClassName.
	self assert: (ClassWith1Var new fOO = 'fOO').
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	self assert: (ClassWith1Var methodDict mareaAt: #fOO) class name equals: #CompiledMethod.
	] ensure: [ 
		aProxy mareaUninstallIfNeeded.
		aProxy2 mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyCategory
	"A simple CompiledMethodProxy test"
	| aProxy |
	self assert: (ClassWith1Var >> #foo) category = #accessing.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	self assert: ClassWith1Var new foo equals: 'foo'.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	self assert: (ClassWith1Var >> #foo) category equals:  #accessing.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyCategory2
	"A simple CompiledMethodProxy test"
	| aProxy |
	self assert: (ClassWith1Var >> #fooCategory) category equals: #'test - category'.
	self assert: (ClassWith1Var organization listAtCategoryNamed: #'test - category') size equals: 1.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	self assert: (ClassWith1Var organization listAtCategoryNamed: #'test - category') size equals: 1.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	self assert: ClassWith1Var new fooCategory equals: 'fooCategory'.
	self assert: (ClassWith1Var methodDict mareaAt: #fooCategory) class name equals: #CompiledMethod.
	self assert: (ClassWith1Var >> #fooCategory) category equals: #'test - category'.
	self assert: (ClassWith1Var organization listAtCategoryNamed: #'test - category') size equals: 1.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyClassMethod
	"A simple CompiledMethodProxy test"
	| aProxy  aProxyClass|
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	aProxyClass := self proxyClass.
	aProxyClass runningTest: false.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) mareaClass equals: aProxyClass.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class equals: CompiledMethod.
	self assert: ClassWith1Var new foo equals: 'foo'.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/14/2011 16:46'!
testCompiledMethodProxyClassMethodNotTesting
	"A simple CompiledMethodProxy test"
	| aProxy |
	self proxyClass runningTest: false.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	self assert: (ClassWith1Var new foo = 'foo').
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/31/2011 12:58'!
testCompiledMethodProxyDNUMessage
	self should: [self proxyClassInstance perform: #zaraza] raise: MessageNotUnderstood.! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyDifficult
	"A simple CompiledMethodProxy test"
	| aProxy |
	
	aProxy := self installCompiledMethodProxyOn: TestRunner selector: #addMethodsUnderTestIn:to:.
	[self assert: (TestRunner methodDict mareaAt: #addMethodsUnderTestIn:to:) class name equals: self proxyClassName.
	TestRunner new addMethodsUnderTestIn: (Array with: (PackageInfo named: 'VMMaker')) to: (OrderedCollection with: CompiledMethod toReturnSelf).
	self assert: (TestRunner methodDict mareaAt: #addMethodsUnderTestIn:to:) class name equals: #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyFlushCache
	"A simple CompiledMethodProxy test"
	| aProxy anObject |
	anObject := ClassWith1Var new. 
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #fooSomething.
	[self assert: (ClassWith1Var methodDict mareaAt: #fooSomething) class name equals: self proxyClassName.
	self assert: anObject fooSomething equals: 'fooSomething'.
	self assert: anObject fooSomething equals: 'fooSomething'.
	self assert: (ClassWith1Var methodDict mareaAt: #fooSomething) class name equals: #CompiledMethod.
	self assert: anObject fooSomething equals: 'fooSomething'.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyInstallTwice
	"A simple CompiledMethodProxy test"
	| aProxy aProxy2 |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	self shouldnt: [aProxy2 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo] raise: Error.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	self assert: ClassWith1Var new foo equals: 'foo'.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/31/2011 15:38'!
testCompiledMethodProxySwapDNUMessage
	"A simple CompiledMethodProxy test"
	
	| aProxy |
	
	aProxy := self installCompiledMethodProxyOn: ClassWithDNU selector: #doesNotUnderstand:.
	
	[self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  self proxyClassName.
	self assert: (ClassWithDNU new doesNotUnderstand: 'zaraza') equals: 'dnu'.
	self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].

	aProxy := self installCompiledMethodProxyOn: ClassWithDNU selector: #doesNotUnderstand:.
	[self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  self proxyClassName.
	self assert: (ClassWithDNU new zaraza) equals: 'dnu'.
	self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].

	aProxy := self installCompiledMethodProxyOn: ClassWithDNU selector: #doesNotUnderstand:.
	[self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  self proxyClassName.
	self should: [(ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) zaraza] raise: MessageNotUnderstood.
	self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].

	aProxy := self installCompiledMethodProxyOn: ClassWithDNU selector: #doesNotUnderstand:.
	[self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  self proxyClassName.
	self should: [(ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) zaraza] raise: MessageNotUnderstood.
	self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].

	aProxy := self installCompiledMethodProxyOn: ClassWithDNU selector: #doesNotUnderstand:.
	[self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  self proxyClassName.
	self should: [(ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) doesNotUnderstand: 'aa'] raise: MessageNotUnderstood.
	"The proxy is uninstalled in this case since it doesn't understand #doesNotUnderstand:"
	self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/31/2011 10:21'!
testCompiledMethodProxySwapOutExternalMethodNeededForSwapIn
	"A simple CompiledMethodProxy test"
	| aProxy aProxy2 internalMethodForTesting |
	"For this test it should be necessary to close all windows that are browsing ClassWith1Var or CompiledMethodProxyHandler"
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	internalMethodForTesting := (CompiledMethodProxySwapperHandler mareaSerializer internalMethodForTesting) copy.
	aProxy2 := self installCompiledMethodProxyOn: internalMethodForTesting methodClass selector: internalMethodForTesting selector.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	"Now...if I want to swap in  any method.....I will have a loop"
	self should: [ClassWith1Var new foo = 'foo'] raise: PossibleLoopDetection.
	] ensure: [
		CompiledMethodProxySwapperHandler mareaForTestingUninstallForProxy: aProxy2 compiledMethod: internalMethodForTesting.
		aProxy mareaUninstallIfNeeded.
	].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/31/2011 10:21'!
testCompiledMethodProxySwapOutInternalMethodNeededForSwapIn
	"A simple CompiledMethodProxy test"
	| aProxy aProxy2 bkpMethod |
	"For this test it should be necessary to close all windows that are browsing ClassWith1Var or CompiledMethodProxyHandler"
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	bkpMethod := (CompiledMethodProxySwapperHandler class methodDict at: #mareaSerializer) copy.
	aProxy2 := self installCompiledMethodProxyOn: CompiledMethodProxySwapperHandler class selector: #mareaSerializer.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	"Now...if I want to swap in  any method.....I will have a loop"
	self should: [ClassWith1Var new foo = 'foo'] raise: PossibleLoopDetection.
	] ensure: [
		CompiledMethodProxySwapperHandler mareaForTestingUninstallForProxy: aProxy2 compiledMethod: bkpMethod.
		aProxy mareaUninstallIfNeeded.
	].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:20'!
testCompiledMethodProxyUnInstall
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	self assert: aProxy mareaIsProxyInstalled.
	"This will automatically uninstall the proxy"
	self assert: ClassWith1Var new foo equals: 'foo'.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	self deny: aProxy mareaIsProxyInstalled.
	] ensure: [ aProxy mareaUninstallIfNeeded].


	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	self assert: aProxy mareaIsProxyInstalled.
	aProxy mareaUninstall.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	self deny: aProxy mareaIsProxyInstalled.
	] ensure: [ aProxy mareaUninstallIfNeeded].! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 12/1/2010 18:07'!
testCompiledMethodProxyUnInstallAllInstances
	"A simple CompiledMethodProxy test"
	| aProxy aProxy2 aProxy3 |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	aProxy2 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo2.
	aProxy3 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo3.
	[self assert: aProxy mareaIsProxyInstalled.
	self assert: aProxy2 mareaIsProxyInstalled.
	self assert: aProxy3 mareaIsProxyInstalled.	
	
	"This will automatically uninstall the proxy"
	self assert: ClassWith1Var new foo equals: 'foo'.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	self deny: aProxy mareaIsProxyInstalled.
	self assert: aProxy2 mareaIsProxyInstalled.
	self assert: aProxy3 mareaIsProxyInstalled.	
	
	self proxyClass mareaUninstallIfNeededAllInstances.
	
	self assert: (ClassWith1Var methodDict mareaAt: #foo2) class name equals: #CompiledMethod.
	self deny: aProxy2 mareaIsProxyInstalled.
	self assert: (ClassWith1Var methodDict mareaAt: #foo3) class name equals: #CompiledMethod.
	self deny: aProxy3 mareaIsProxyInstalled.
	
	] ensure: [ 
		aProxy mareaUninstallIfNeeded.
		aProxy2 mareaUninstallIfNeeded.
		aProxy3 mareaUninstallIfNeeded.].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:22'!
testCompiledMethodProxyUnInstallMultipleTimes
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	self assert: aProxy mareaIsProxyInstalled.
	aProxy mareaUninstall.
	self should: [aProxy mareaUninstall.] raise: ProxyIsNotInstalled.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	self deny: aProxy mareaIsProxyInstalled.
	] ensure: [ aProxy mareaUninstallIfNeeded].! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 12/2/2010 17:00'!
testMethodDictionaryForRecoveringProxiesAssociationsDo
	| aProxy methodSize aProxy2 aProxy3 |
	
	methodSize := (ClassWith1Var >> #foo) size.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	aProxy2 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo2.
	aProxy3 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo3.

	[ClassWith1Var methodDict associationsDo:  [:assoc | self deny: assoc value mareaIsProxy. ].
	
	self deny: aProxy mareaIsProxyInstalled. 
	self deny: aProxy mareaIsProxyInstalled. 
	self deny: aProxy mareaIsProxyInstalled. 
	] ensure: [ 
		aProxy mareaUninstallIfNeeded.
		aProxy2 mareaUninstallIfNeeded.
		aProxy3 mareaUninstallIfNeeded.
	].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 12/2/2010 17:01'!
testMethodDictionaryForRecoveringProxiesAtIfAbsent
	| aProxy methodSize aProxy2 aProxy3 |
	
	methodSize := (ClassWith1Var >> #foo) size.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	aProxy2 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo2.
	aProxy3 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo3.
.
	[self deny: (ClassWith1Var methodDict at: #foo ifAbsent: []) mareaIsProxy.
	
	self deny: aProxy mareaIsProxyInstalled. 
	self assert: aProxy2 mareaIsProxyInstalled. 
	self assert: aProxy3 mareaIsProxyInstalled. 
	] ensure: [ 
		aProxy mareaUninstallIfNeeded.
		aProxy2 mareaUninstallIfNeeded.
		aProxy3 mareaUninstallIfNeeded.
	].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 12/2/2010 17:00'!
testMethodDictionaryForRecoveringProxiesValuesDo
	| aProxy methodSize aProxy2 aProxy3 |
	
	methodSize := (ClassWith1Var >> #foo) size.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	aProxy2 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo2.
	aProxy3 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo3.

	[ClassWith1Var methodDict valuesDo: [:method | self deny: method mareaIsProxy. ].
	
	self deny: aProxy mareaIsProxyInstalled. 
	self deny: aProxy mareaIsProxyInstalled. 
	self deny: aProxy mareaIsProxyInstalled. 
	] ensure: [ 
		aProxy mareaUninstallIfNeeded.
		aProxy2 mareaUninstallIfNeeded.
		aProxy3 mareaUninstallIfNeeded.
	].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/30/2010 18:08'!
testSelector 
	^ testSelector ! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/31/2011 10:21'!
testSerializeCompiledMethod
	| method newMethod serializer |
method := ClassWith1Var >> #foo.
	"method := FormCanvas>> #transformBy:clippingTo:during:smoothing:.
	"
	"
method := (Refactoring class>>#initializeRefactoringOptions ).

method := RefactoryChangeManager class >> #settingsOn:.
"
	serializer := CompiledMethodProxySwapperHandler mareaSerializer. 
	
	"
	serializer := FuelMareaSerializer new.
	"
	
	serializer mareaSerializeAndWriteObject: method to: 'zaraza'.
	
	newMethod := serializer mareaUnserializeObjectFrom:  'zaraza'.

	self assert: method = newMethod.
	! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 11/30/2010 17:30'!
xtestCompiledMethodProxyWhenBothUnderstandSameMessage
	| aProxy methodSize |
	methodSize := (ClassWith1Var >> #foo) size.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  self proxyClassName.
	self deny: (ClassWith1Var methodDict mareaAt: #foo) size = aProxy size. 
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) size = methodSize. 
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

AbstractCompiledMethodProxyTest subclass: #CompiledMethodProxyFuelSmallIntegerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!CompiledMethodProxyFuelSmallIntegerTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/31/2011 10:21'!
setUp
	CompiledMethodProxySwapperHandler mareaSerializer: FuelMareaSerializer. 
	SmallInteger runningTest: true.
	proxyClass := SmallInteger.
	proxyInstance := 42! !

AbstractCompiledMethodProxyTest subclass: #CompiledMethodProxyFuelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!CompiledMethodProxyFuelTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/31/2011 10:21'!
setUp
	CompiledMethodProxySwapperHandler mareaSerializer: FuelMareaSerializer. 
	FilenameCompiledMethodProxySwapper runningTest: true.
	proxyClass := FilenameCompiledMethodProxySwapper.
	proxyInstance := FilenameCompiledMethodProxySwapper new! !

AbstractCompiledMethodProxyTest subclass: #CompiledMethodProxyReferenceStreamSmallIntegerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!CompiledMethodProxyReferenceStreamSmallIntegerTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/31/2011 10:21'!
setUp
	CompiledMethodProxySwapperHandler mareaSerializer: ReferenceStreamMareaSerializer. 
	SmallInteger runningTest: true.
	proxyClass := SmallInteger.
	proxyInstance := 42! !

AbstractCompiledMethodProxyTest subclass: #CompiledMethodProxyReferenceStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!CompiledMethodProxyReferenceStreamTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/31/2011 10:21'!
setUp
	CompiledMethodProxySwapperHandler mareaSerializer: ReferenceStreamMareaSerializer. 
	FilenameCompiledMethodProxySwapper runningTest: true.
	proxyClass := FilenameCompiledMethodProxySwapper.
	proxyInstance := FilenameCompiledMethodProxySwapper new! !

AbstractCompiledMethodProxyTest subclass: #CompiledMethodProxySmallIntegerFuelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!CompiledMethodProxySmallIntegerFuelTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/31/2011 10:21'!
setUp
	CompiledMethodProxySwapperHandler mareaSerializer: FuelMareaSerializer. 
	CompiledMethodProxySmallInteger runningTest: true.
	proxyClass := CompiledMethodProxySmallInteger.
	proxyInstance := CompiledMethodProxySmallInteger new


! !

AbstractCompiledMethodProxyTest subclass: #CompiledMethodProxySmallIntegerReferenceStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!CompiledMethodProxySmallIntegerReferenceStreamTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/31/2011 10:21'!
setUp
	CompiledMethodProxySwapperHandler mareaSerializer: ReferenceStreamMareaSerializer. 
	CompiledMethodProxySmallInteger runningTest: true.
	proxyClass := CompiledMethodProxySmallInteger.
	proxyInstance := CompiledMethodProxySmallInteger new


! !

TestCase subclass: #ClassProxyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!ClassProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/17/2011 15:18'!
installClassProxyOn: aClass
	^ self proxyClass installOn: aClass
! !

!ClassProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 3/13/2011 12:45'!
proxyClass
	^ ClassProxy ! !

!ClassProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 3/13/2011 20:29'!
setUp

	(FileDirectory default fileNamesMatching: '*.swap*') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
	self proxyClass runningTest: true.
	! !

!ClassProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 3/13/2011 12:45'!
testClassSwapRestoreByClass
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message directly to the class"
	
	| aProxy className |
	className := ClassWith1Var name.
	aProxy := self installClassProxyOn: ClassWith1Var.
	"after this is done, aProxy is pointing to ClassWith1Var"
	[self assert: (Smalltalk at: className) ==  ClassWith1Var.
	self assert: (Smalltalk at: className) mareaClass name equals: #ClassProxy.
	self assert: (Smalltalk at: className) mareaIsProxyInstalled.
	"We are sure that the proxy was installed, now, lets uninstall it sending any message to the class"
	self assert: (Smalltalk at: className) fooClass equals: 'fooClass'.
	"Now lets check that the proxy was uninstalled"
	self assert: (Smalltalk at: className) mareaClass name equals: 'ClassWith1Var class'.
	self assert: (Smalltalk at: className) name equals: 'ClassWith1Var'.
	self deny: aProxy mareaIsProxyInstalled
	] ensure: [ aProxy mareaIsProxy ifTrue:  [ aProxy mareaUninstallIfNeeded]].
! !

!ClassProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 3/21/2011 20:51'!
testClassSwapRestoreByClassAndIsCompact

	| aProxy className |
	className := CompactClassMock name.
	self should: [self installClassProxyOn: CompactClassMock] raise: CannotProxifyCompactClasses  

! !

!ClassProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 3/13/2011 12:45'!
testClassSwapRestoreByClassAndNotUnderstood
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message directly to the class"
	
	|  aProxy className |
	className := ClassWith1Var name.
	aProxy := self installClassProxyOn: ClassWith1Var.
	"after this is done, aProxy is pointing to ClassWith1Var"
	[self assert: (Smalltalk at: className) ==  ClassWith1Var.
	self assert: (Smalltalk at: className) mareaClass name equals: #ClassProxy.
	self assert: (Smalltalk at: className) mareaIsProxyInstalled.
	"We are sure that the proxy was installed, now, lets uninstall it sending any message to the class"
	self should: [ (Smalltalk at: className) zaraza ] raise: Error.
	"Now lets check that the proxy was uninstalled"
	self assert: (Smalltalk at: className) mareaClass name equals: 'ClassWith1Var class'.
	self assert: (Smalltalk at: className) name equals: 'ClassWith1Var'.
	self deny: aProxy mareaIsProxyInstalled
	] ensure: [ aProxy mareaIsProxy ifTrue:  [ aProxy mareaUninstallIfNeeded]].
! !

!ClassProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 3/13/2011 12:45'!
testClassSwapRestoreByClassAndUnderstoodByBoth
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message directly to the class"
	
	|  aProxy className |
	className := ClassWith1Var name.
	aProxy := self installClassProxyOn: ClassWith1Var.
	"after this is done, aProxy is pointing to ClassWith1Var"
	[self assert: (Smalltalk at: className) ==  ClassWith1Var.
	self assert: (Smalltalk at: className) mareaClass name equals: #ClassProxy.
	self assert: (Smalltalk at: className) mareaIsProxyInstalled.
	"We are sure that the proxy was installed, now, lets uninstall it sending any message to the class"
	 (Smalltalk at: className) basicIdentityHash.
	 (Smalltalk at: className) == Object new.
	"Notice that #basicIdentityHash  #==  ARE understood by both, the original object and the proxy, so, the proxy is not uninstalled. This is because in this case, the uninstall happens when the #doesNotUnderstand is caled. 
	What is worth, the CLIENT of the original object may send a message to it, and the proxy would answer a different value and not uninstalling the proxy. This can be a problem, but it is something we may want to live with."
	self assert: (Smalltalk at: className) ==  ClassWith1Var.
	self assert: (Smalltalk at: className) mareaClass name equals: #ClassProxy.
	self assert: (Smalltalk at: className) mareaIsProxyInstalled.
	] ensure: [ aProxy mareaIsProxy ifTrue:  [ aProxy mareaUninstallIfNeeded]].
! !

!ClassProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 3/13/2011 12:45'!
testClassSwapRestoreByInstances
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message to an instance of it."
	
	| inst aProxy className |
	inst := ClassWith1Var new.
	className := ClassWith1Var name.
	aProxy := self installClassProxyOn: ClassWith1Var.
	"after this is done, aProxy is pointing to ClassWith1Var"
	[self assert: (Smalltalk at: className) ==  ClassWith1Var.
	self assert: (Smalltalk at: className) mareaClass name equals: #ClassProxy.
	self assert: (Smalltalk at: className) mareaIsProxyInstalled.
	"We are sure that the proxy was installed, now, lets uninstall it sending any message to the class"
	self assert: inst foo equals: 'foo'.
	"Now lets check that the proxy was uninstalled"
	self assert: (Smalltalk at: className) mareaClass name equals: 'ClassWith1Var class'.
	self assert: (Smalltalk at: className) name equals: 'ClassWith1Var'.
	self deny: aProxy mareaIsProxyInstalled
	] ensure: [ aProxy mareaIsProxy ifTrue:  [ aProxy mareaUninstallIfNeeded]].
! !

!ClassProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 3/21/2011 20:46'!
testClassSwapRestoreByInstancesAndClassIsCompact
	"With this test I want to demonstrate that we have a problem with compact classes. It doesn't work when having compact classes, since their instances, do not have a class pointer, and hence, the #become: doesn't update those pointers to point to my proxy. So....nothing to do."

	| inst aProxy className |
	inst := ClassWith1Var new.
	className := CompactClassMock name.
	self should: [self installClassProxyOn: CompactClassMock] raise: CannotProxifyCompactClasses.
	! !

!ClassProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 3/13/2011 12:45'!
testClassSwapRestoreByInstancesAndNotUnderstood
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message to an instance of it."
	
	| inst aProxy className |
	inst := ClassWith1Var new.
	className := ClassWith1Var name.
	aProxy := self installClassProxyOn: ClassWith1Var.
	"after this is done, aProxy is pointing to ClassWith1Var"
	[self assert: (Smalltalk at: className) ==  ClassWith1Var.
	self assert: (Smalltalk at: className) mareaClass name equals: #ClassProxy.
	self assert: (Smalltalk at: className) mareaIsProxyInstalled.
	"We are sure that the proxy was installed, now, lets uninstall it sending any message to the class"
	self should: [inst zaraza] raise: Error.
	"Now lets check that the proxy was uninstalled"
	self assert: (Smalltalk at: className) mareaClass name equals: 'ClassWith1Var class'.
	self assert: (Smalltalk at: className) name equals: 'ClassWith1Var'.
	self deny: aProxy mareaIsProxyInstalled
	] ensure: [ aProxy mareaIsProxy ifTrue:  [ aProxy mareaUninstallIfNeeded]].
! !

!ClassProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 3/13/2011 12:45'!
testClassSwapRestoreByInstancesAndUnderstoodByBoth
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message to an instance of it."
	
	|  inst aProxy className |
	inst := ClassWith1Var new.
	className := ClassWith1Var name.
	aProxy := self installClassProxyOn: ClassWith1Var.
	"after this is done, aProxy is pointing to ClassWith1Var"
	[self assert: (Smalltalk at: className) ==  ClassWith1Var.
	self assert: (Smalltalk at: className) mareaClass name equals: #ClassProxy.
	self assert: (Smalltalk at: className) mareaIsProxyInstalled.
	"We are sure that the proxy was installed, now, lets uninstall it sending any message to the class"
	 inst basicIdentityHash.
	 inst == Object new.
	"Notice that #basicIdentityHash  #==  ARE understood by both, the original object and the proxy, but in this case, the proxy IS uninstalled. Why?  because in this case, the uninstall happens because of the #cannotInterpret instead of the #doesNotUnderstand.  When using #cannotInterpret, we handle ANY message, not only the ones not understood. "
	self assert: (Smalltalk at: className) mareaClass name equals: 'ClassWith1Var class'.
	self assert: (Smalltalk at: className) name equals: 'ClassWith1Var'.
	self deny: aProxy mareaIsProxyInstalled.
	] ensure: [ aProxy mareaIsProxy ifTrue:  [ aProxy mareaUninstallIfNeeded]].

! !

!ClassProxyTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/23/2011 15:44'!
testClassSwapSimple

	| inst aProxy |
	inst := ClassWith1Var new.
	aProxy := self installClassProxyOn: ClassWith1Var.
	[ self assert: (inst class == ClassWith1Var).
	self assert: inst foo = 'foo'.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

TestCase subclass: #DeprecatedObjectProxyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!DeprecatedObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 15:04'!
XXXXtestOneClassObjectsInner
		
	| b a proxy |
	
	b := ClassWith2Var. 
	a := ClassWith1Var new var1: b.
	
	"We put a proxy and become for B."
	DeprecatedObjectSwapper new swap: b.
	Transcript show: 'antes';cr.
	self assert: a var1 name = AClassProxy name. 
	Transcript show: 'desp';cr.
	a var1 new class.
	self assert: a var1 new class = ClassWith2Var.
	Transcript show: 'mas desp';cr.
	self assert: a var1 class = ClassWith2Var. 
	Transcript show: 'ree desp';cr.! !

!DeprecatedObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/21/2010 19:08'!
tearDown
	(FileDirectory default fileNamesMatching: '*.swap') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].! !

!DeprecatedObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 15:04'!
testAllNomralObjectsAllInner
	"A points to B which is an array that points to C and D. All are normal and inner objects"	
	| c d b a proxy fileName hello today initialInstances finalInstances |
	
	hello := 'Hello'.
	today := Date today.
	
	c := ClassWith1Var new var1: hello.
	d := ClassWith1Var new var1: today.
	b := Array with: c with: d.
	a := ClassWith1Var new var1: b.
	
	3 timesRepeat: [Smalltalk garbageCollect].
	initialInstances := ClassWith1Var instanceCount. 
	d := c := nil.
	
	"We put a proxy and become for B."
	proxy := DeprecatedObjectProxy new.
	proxy become: b.
	
	3 timesRepeat: [Smalltalk garbageCollect].
	finalInstances := ClassWith1Var instanceCount. 
	"Since nobody else point to B after the become, D an C should be garbage collected"
	self assert: finalInstances = (initialInstances - 2). 
	

	self assert: a var1 = b.
	"With this, using the DNU the proxy will load back the objects"
	self assert: (a var1 first var1 = hello).
	self assert: (a var1 last var1 = today).
	self assert:  ClassWith1Var instanceCount = initialInstances.! !

!DeprecatedObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 15:04'!
testAllNomralObjectsInnerAndShared
	"A points to B which is an array that points to C and D. All are normal and inner objects"	
	| c d b a proxy fileName hello today initialInstances finalInstances |
	
	hello := 'Hello'.
	today := Date today.
	
	c := ClassWith1Var new var1: hello.
	d := ClassWith1Var new var1: today.
	b := Array with: c with: d.
	a := ClassWith1Var new var1: b.
	
	Smalltalk garbageCollect.
	initialInstances := ClassWith1Var instanceCount. 
	d :=  nil.
	"We only nil D. C is still pointing, thus, it is a shared object."
	
	"We put a proxy and become for B."
	proxy := DeprecatedObjectProxy new.
	proxy become: b.
	
	Smalltalk garbageCollect.
	finalInstances := ClassWith1Var instanceCount. 
	"Since nobody else point to B after the become, D (C will not) should be garbage collected"
	self assert: finalInstances = (initialInstances - 1). 
	

	self assert: a var1 == b.
	"With this, using the DNU the proxy will load back the objects"
	self assert: (a var1 first var1 = hello).
	self assert: (a var1 last var1 = today).
	"We cannot get duplicates of C."
	self assert:  ClassWith1Var instanceCount = initialInstances.
! !

!DeprecatedObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 15:04'!
testObjectProxyClassMessageEquality
	| proxy fileName anObject |
	
	anObject := ClassWith1Var new.
	anObject var1: 'something'.
	proxy := DeprecatedObjectProxy new.
	
	self assert: anObject class == ClassWith1Var. 
	
	proxy become: anObject.
	
	"We should be always able to get the real class of an object, for out internal usage."
	self assert: anObject mareaClass == DeprecatedObjectProxy.  
	self assert: (anObject mareaClass name = #DeprecatedObjectProxy).
	
	self assert: anObject class == ClassWith1Var. 
	self assert: (anObject class name == #ClassWith1Var).
	"This will be useful for code like:
	[anObject class == ClassWith1Var] ifTrue: [ doSomething ]
	If this assert doesnt work, then that code will be broken."
	
	"I don't this a class will overried = but in such case, this should be true anyway:"
	self assert: anObject class = ClassWith1Var. 
	self assert: (anObject class name = #ClassWith1Var).
		
	self assert: (anObject var1 = 'something').
! !

!DeprecatedObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 15:04'!
testObjectProxyClassMessageNextInstance
	| proxy fileName anObject |
	
	anObject := ClassWith1Var new.
	anObject var1: 'something'.
	proxy := DeprecatedObjectProxy new.
	
	self assert: anObject class == ClassWith1Var. 
	
	proxy become: anObject.
	
	self assert: (ClassWith1Var someInstance class = ClassWith1Var).
	self assert: (anObject nextInstance class = ClassWith1Var).
	
	self assert: anObject class == ClassWith1Var. 
	self assert: (anObject class name = #ClassWith1Var).

	"Now....do we want that #class loads back the original object"
	anObject isByteString.
	
	self assert: (anObject var1 = 'something').
	self assert: anObject class = ClassWith1Var. 
	self assert: (anObject class name = #ClassWith1Var).
	! !

!DeprecatedObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 15:04'!
testObjectProxyClassMethods
	| proxy fileName anObject |
	
	anObject := ClassWith1Var new.
	anObject var1: 'something'.
	proxy := DeprecatedObjectProxy new.
	
	self assert: anObject class fooClass = 'fooClass'.

	proxy become: anObject.
	
	"Even if the object was swapped, the class has to understand fooClass"
	self assert: anObject class == ClassWith1Var. 
	self assert: anObject class fooClass = 'fooClass'.
	
	self assert: (anObject class name = #ClassWith1Var).

	self assert: (anObject var1 = 'something').
	! !

!DeprecatedObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 15:04'!
testObjectProxyClassMethods2
	| proxy fileName anObject |
	
	anObject := ClassWith1Var new.
	anObject var1: 'something'.
	proxy := DeprecatedObjectProxy new.
	
	self assert: anObject class fooClass = 'fooClass'.

	proxy become: anObject.
	
	"Even if the object was swapped, the class has to understand fooClass"
	self assert: ClassWith1Var fooClass = 'fooClass'.
	self assert: anObject class == ClassWith1Var. 
	self assert: (anObject class name = #ClassWith1Var).

	self assert: (anObject var1 = 'something').
	! !

!DeprecatedObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 15:04'!
testOneSingleObject
	| proxy fileName anObject |
	
	anObject := 'Hello'.
	
	"We put a proxy and become for B."
	proxy := DeprecatedObjectProxy new.
	
	proxy become: anObject.
	
	self assert: (anObject class name = #DeprecatedObjectProxy).
	
	anObject isByteString.
	"With this, using the DNU the proxy will load back the objects"
	self assert: (anObject = 'Hello').
	self assert: (anObject class name = 'Hello' class name).
	! !

!DeprecatedObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 15:04'!
testOneSingleObjectProxyUndetstandsDNU
	"The object that we swap does also understand the message doesNotUnderstand. We have to be sure not to loop and to correctly call both doesNotUnderstand:"
	| proxy fileName anObject |
	
	anObject := ClassWithDNU new.
	
	proxy := DeprecatedObjectProxy new.
	proxy become: anObject.
	
	self assert: (anObject class name = #DeprecatedObjectProxy).
	self assert: anObject fooSomething = 'fooSomethingProxy'.
	self assert: (anObject class name = #DeprecatedObjectProxy).
	
	self assert: (anObject perform: #unExistentMethod) = 'dnu'.
	self assert: (anObject class name =  ClassWithDNU name).
	
	! !

!DeprecatedObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 15:04'!
testOneSingleObjectProxyUndetstandsMessage
	"The proxy does understand the message fooSomething. This can be a problem and this is why proxies should subclass from ProtoObject."
	| proxy fileName anObject |
	
	anObject := 'Hello'.
	
	"We put a proxy and become for B."
	proxy := DeprecatedObjectProxy new.
	proxy become: anObject.
	
	self assert: (anObject class name = #DeprecatedObjectProxy).
	self assert: anObject fooSomething = 'fooSomethingProxy'.
	self assert: (anObject class name = #DeprecatedObjectProxy).
	
	anObject isByteString.
	self assert: (anObject class name =  'Hello' class name).
	
	! !

!DeprecatedObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 15:04'!
testOneSingleObjectProxyUndetstandsMessageOverridden
	"The proxy does understand the message fooSomething, but the original class also understand fooSomething. In this test we can see this is a problem, since the fooSomething of the proxy will be executed instead of the one of the original objects, generating random problems. To avoid this problem, we named all of our proxy methods names, with a special prefix."
	| proxy fileName anObject |
	
	anObject := ClassWith1Var new .
	
	"We put a proxy and become for B."
	proxy := DeprecatedObjectProxy new.
	proxy become: anObject.
	
	self assert: (anObject class name = #DeprecatedObjectProxy).
	"this is the problem. We should have 'fooSomething' as an answer, and not 'fooSomethingProxy'. " 
	self assert: anObject fooSomething = 'fooSomethingProxy'.
	self assert: (anObject class name = #DeprecatedObjectProxy).
	
	anObject foo.
	self assert: (anObject class name =  ClassWith1Var name).
	
	! !

!DeprecatedObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 15:04'!
testOneSingleObjectProxyWithDNU
	"The object that we swap does not understand a the message. This should swap in the object, then thrown DNU error."
	| proxy fileName anObject |
	
	anObject := ClassWith1Var new.
	
	proxy := DeprecatedObjectProxy new.
	proxy become: anObject.
	
	self assert: (anObject class name = #DeprecatedObjectProxy).
	self assert: anObject fooSomething = 'fooSomethingProxy'.
	self assert: (anObject class name = #DeprecatedObjectProxy).
	
	self should: [(anObject perform: #unExistentMethod)] raise: Error.
	self assert: (anObject class name =  ClassWith1Var name).
	
	
! !

!DeprecatedObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 15:04'!
testOneSingleObjectSpecialBytecodes
	| proxy fileName anObject |
	
	anObject := 'Hello'.
	
	"We put a proxy and become for B."
	proxy := DeprecatedObjectProxy new.
	proxy become: anObject.
	
	self assert: (anObject class name = #DeprecatedObjectProxy).
	self assert: anObject fooSomething = 'fooSomethingProxy'.
	self assert: (anObject class name = #DeprecatedObjectProxy).
	
	anObject class.
	self assert: (anObject class name = #DeprecatedObjectProxy).
	
	anObject isByteString.
	self assert: (anObject class name =  'Hello' class name).
	
	! !

!DeprecatedObjectProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 15:04'!
testOneSingleObjectSpecialSelector
	| proxy fileName anObject |
	
	anObject := 1.5.
	
	"We put a proxy and become for B."
	proxy := DeprecatedObjectProxy new.
	
	proxy become: anObject.
	
	self assert: (anObject class name = #DeprecatedObjectProxy).
	
	anObject + 3.2.
	"With this, using the DNU the proxy will load back the objects"
	self assert: (anObject = 1.5).
	self assert: (anObject class name = 1.5 class name).
	! !

TestCase subclass: #ObjectProxySwapperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!ObjectProxySwapperTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/13/2011 18:38'!
installProxyOn: anObject. 
	^ self proxyClass installOn: anObject.! !

!ObjectProxySwapperTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 15:49'!
proxyClass
	^ NumberAsFilenameObjectProxySwapper! !

!ObjectProxySwapperTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/13/2011 20:29'!
setUp

	(FileDirectory default fileNamesMatching: '*.swap*') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
	self proxyClass runningTest: true.
	! !

!ObjectProxySwapperTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/13/2011 18:01'!
tearDown
"	(FileDirectory default fileNamesMatching: '*.swap') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ]."! !

!ObjectProxySwapperTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 12:32'!
testClassSelector
	| anObject |
	
	anObject := DateAndTime new.
	
	self installProxyOn: anObject. 
	
	[self assert: anObject mareaClass equals: self proxyClass.
	self assert: anObject mareaIsProxyInstalled.
	anObject class.
	anObject mareaClass.
	"all methos that start with marea are understood"
	self assert: anObject mareaIsProxyInstalled.
	
	self proxyClass runningTest: false.
	"since we are not running tests, #class should uninstall the proxy"
	anObject class.
	
	self assert: anObject class equals: DateAndTime.

	] ensure: [ anObject mareaIsProxy ifTrue:  [ anObject mareaUninstallIfNeeded]].

! !

!ObjectProxySwapperTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 17:16'!
testIdentity
	| anObject anotherPointer |
	
	anObject := DateAndTime new.
	anotherPointer := anObject.
	
	self installProxyOn: anObject. 
	
	[self assert: anObject mareaClass equals: self proxyClass..
	self assert: anObject mareaIsProxyInstalled.
	anObject mareaUninstallIfNeeded.
	self assert: anotherPointer == anObject.

	] ensure: [ anObject mareaIsProxy ifTrue:  [ anObject mareaUninstallIfNeeded]].

! !

!ObjectProxySwapperTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 12:31'!
testOneSingleObject
	| anObject |
	
	anObject := DateAndTime new.
	
	self installProxyOn: anObject. 
	
	[self assert: anObject mareaClass equals: self proxyClass.
	self assert: anObject mareaIsProxyInstalled.
	anObject name.
	self assert: anObject class equals: DateAndTime.

	] ensure: [ anObject mareaIsProxy ifTrue:  [ anObject mareaUninstallIfNeeded]].

! !

!ObjectProxySwapperTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 16:41'!
testOneSingleObjectProxyDNU

	| anObject |
	
	anObject := ClassWith1Var new.
	self installProxyOn: anObject. 
	[self assert: anObject class equals: self proxyClass.
	self assert: anObject mareaIsProxyInstalled.

	self should: [anObject zaraza] raise: MessageNotUnderstood.
	
	self assert: anObject class equals: ClassWith1Var.

	] ensure: [ anObject mareaIsProxy ifTrue:  [ anObject mareaUninstallIfNeeded]].
! !

!ObjectProxySwapperTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 12:31'!
testOneSingleObjectProxyUndetstandsDNU
	"The object that we swap does also understand the message doesNotUnderstand. We have to be sure not to loop and to correctly call both doesNotUnderstand:"
	| anObject |
	
	anObject := ClassWithDNU new.
	self installProxyOn: anObject. 
	[self assert: anObject class equals: self proxyClass.
	self assert: anObject mareaIsProxyInstalled.
	self assert: anObject zaraza equals: 'dnu'.
	self assert: anObject class equals: ClassWithDNU.

	] ensure: [ anObject mareaIsProxy ifTrue:  [ anObject mareaUninstallIfNeeded]].
! !

TestCase subclass: #ObjectProxyTracerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!ObjectProxyTracerTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 16:12'!
installProxyOn: anObject. 
	^ self proxyClass installOn: anObject withHandler: ObjectProxyTracerHandler.! !

!ObjectProxyTracerTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 16:12'!
proxyClass
	^ ObjectProxyWithTarget! !

!ObjectProxyTracerTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 16:12'!
setUp

	self proxyClass runningTest: true.
	! !

!ObjectProxyTracerTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 16:57'!
testClassSelector
	| anObject proxy |
	
	anObject := DateAndTime new.
	
	proxy := self installProxyOn: anObject. 
	
	[self assert: proxy mareaClass equals: self proxyClass.
	self assert: proxy class equals: self proxyClass.
	self assert: proxy mareaIsProxyInstalled.
	"all methos that start with marea are understood. And #class too"
	self assert: proxy mareaIsProxyInstalled.
	
	self proxyClass runningTest: false.
	self assert: proxy class equals: DateAndTime.
	self assert: proxy mareaClass equals: self proxyClass.
	
	proxy mareaUninstallIfNeeded.
	self assert: proxy class equals: self proxyClass.
	self assert: proxy mareaClass equals: self proxyClass.
	
	] ensure: [ proxy mareaUninstallIfNeeded].

! !

!ObjectProxyTracerTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 17:19'!
testIdentity
	| anObject proxy |
	
	anObject := DateAndTime new.
	
	proxy := self installProxyOn: anObject. 
	
	[self assert: proxy mareaClass equals: self proxyClass..
	self assert: proxy mareaIsProxyInstalled.
	self deny: proxy == anObject.
	proxy mareaUninstallIfNeeded.
	self deny: proxy == anObject.

	] ensure: [ anObject mareaIsProxy ifTrue:  [ anObject mareaUninstallIfNeeded]].

! !

!ObjectProxyTracerTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 19:01'!
testOneSingleObject
	| anObject aProxy |
	
	anObject := 'jejejejej'.
	
	aProxy := self installProxyOn: anObject. 
	
	[self assert: aProxy mareaClass equals: self proxyClass.
	self assert: aProxy mareaIsProxyInstalled.
	self assert: (aProxy includesSubString: 'jeje').
	self assert: aProxy= anObject.
	aProxy mareaUninstallIfNeeded.
	self deny: aProxy mareaIsProxyInstalled.
	self deny: aProxy = anObject.
	self should: [aProxy includesSubString: 'jeje'] raise: MessageNotUnderstood.
	] ensure: [ aProxy mareaUninstallIfNeeded].

! !

!ObjectProxyTracerTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 16:43'!
testOneSingleObjectProxyDNU

	| anObject proxy |
	
	anObject := ClassWith1Var new.
	proxy := self installProxyOn: anObject. 
	[self assert: proxy class equals: self proxyClass.
	self assert: proxy mareaIsProxyInstalled.
	
	self should: [proxy zaraza] raise: MessageNotUnderstood.
	

	] ensure: [ proxy mareaUninstallIfNeeded].
! !

!ObjectProxyTracerTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 16:45'!
testOneSingleObjectProxyUndetstandsDNU
	"The object that we swap does also understand the message doesNotUnderstand. We have to be sure not to loop and to correctly call both doesNotUnderstand:"
	| anObject proxy |
	
	anObject := ClassWithDNU new.
	proxy := self installProxyOn: anObject. 
	
	[self assert: proxy class equals: self proxyClass.
	self assert: proxy mareaIsProxyInstalled.
	self assert: proxy zaraza equals: 'dnu'.
	
	] ensure: [ proxy mareaUninstallIfNeeded].
! !

!MareaSerializer methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 11/24/2010 23:29'!
internalMethodForTesting
	^ self shouldBeImplemented ! !

!DeprecatedObjectProxy methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 11/17/2010 20:11'!
class
	self mareaLog: 'Will restore object'.
	self become: self mareaLoadBackSerializedObjectsFromFile.
	self mareaLog: 'Object was restored'.
	^ self class! !

!DeprecatedObjectProxy methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 10/17/2010 19:13'!
fooSomething
	^ 'fooSomethingProxy'! !

!ReferenceStreamMareaSerializer methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 11/24/2010 23:29'!
internalMethodForTesting
	^ ReferenceStream methodDict at: #next.! !

!FuelMareaSerializer methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 11/24/2010 23:38'!
internalMethodForTesting
	^ FLMaterializer methodDict at: #materialize! !

!TestSuite methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 11/30/2010 18:07'!
tests: aCollectionOfTests
	tests := aCollectionOfTests 
			! !

!ClassProxyHandler classSide methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 1/17/2011 15:36'!
mareaForTestingUninstallForProxy: aProxy compiledMethod: aMethod
	| oldMethod |
	aProxy mareaIsProxyInstalled ifFalse: [^ nil].
	oldMethod := aMethod.
	self mareaLog: 'The CompiledMethod ', oldMethod mareaPrintString, ' was loaded form file.'.
	oldMethod methodClass  methodDict at: (oldMethod selector) put: oldMethod.
	self mareaLog: 'The Proxy for ', oldMethod mareaPrintString, ' was uninstalled.'.
	self mareaRemoveFile: aProxy mareaFileName.
	aProxy mareaMarkAsUninstalled.
	^ oldMethod.  
! !

!ProtoObject methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 11/30/2010 15:43'!
size
	^ -1! !

!CompiledMethodProxySwapperHandler classSide methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 11/28/2010 20:13'!
mareaForTestingUninstallForProxy: aProxy compiledMethod: aMethod
	| oldMethod |
	aProxy mareaIsProxyInstalled ifFalse: [^ nil].
	oldMethod := aMethod.
	self mareaLog: 'The CompiledMethod ', oldMethod mareaPrintString, ' was loaded form file.'.
	oldMethod methodClass  methodDict at: (oldMethod selector) put: oldMethod.
	self mareaLog: 'The Proxy for ', oldMethod mareaPrintString, ' was uninstalled.'.
	self mareaRemoveFile: aProxy mareaFileName.
	aProxy mareaMarkAsUninstalled.
	^ oldMethod.  
! !
